/*
 *  ngtk/c/ngtk_pbar.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>

ngtk_pbar_t *ngtk_mk_pbar(int width)
{
    ngtk_pbar_t *ret_pbar = (ngtk_pbar_t *)malloc(sizeof(ngtk_pbar_t));

	ret_pbar->container = (ngtk_win_t *)NULL;
    ret_pbar->width = width;
    ret_pbar->percent = 0;

    return(ret_pbar);
}

void ngtk_show_pbar(ngtk_pbar_t *c_pbar, int top, int left, int cpair, int attr)
{
    c_pbar->container = ngtk_push_win(2, c_pbar->width+1, top, left, cpair, attr, 0, 0);

    ngtk_clrwin(c_pbar->container->win, 32, 1);
    ngtk_minibox(c_pbar->container, 2, c_pbar->width, 0, 0, 1, 0, 1);
}

void ngtk_update_pbar(ngtk_pbar_t *c_pbar, int percentage)
{
    int index = (percentage * c_pbar->width) / 100;

	ngtk_pull_win(c_pbar->container);

    if (c_pbar->percent > percentage)
        ngtk_minibox(c_pbar->container, 2, c_pbar->width, 0, 0, 1, 0, 1);

    ngtk_minibox(c_pbar->container, 2, index, 0, 0, 1, 1, 1);
    c_pbar->percent = percentage;
}

void ngtk_destroy_pbar(ngtk_pbar_t *c_pbar)
{
	ngtk_pull_win(c_pbar->container);
    ngtk_pop_win(c_pbar->container);

    free(c_pbar);
}
